| Home | Libraries | People | FAQ | More

# boost::asio::write

## Functions

template<typename Sync_Write_Stream, typename Const_Buffers>
std::size_t | boost::asio::write (Sync_Write_Stream &s, const Const_Buffers &buffers)
| Write all of the supplied data to a stream before returning.
template<typename Sync_Write_Stream, typename Const_Buffers, typename Completion_Condition>
std::size_t | boost::asio::write (Sync_Write_Stream &s, const Const_Buffers &buffers, Completion_Condition completion_condition)
| Write a certain amount of data to a stream before returning.
template<typename Sync_Write_Stream, typename Const_Buffers, typename Completion_Condition, typename Error_Handler>
std::size_t | boost::asio::write (Sync_Write_Stream &s, const Const_Buffers &buffers, Completion_Condition completion_condition, Error_Handler error_handler)
| Write a certain amount of data to a stream before returning.
template<typename Sync_Write_Stream, typename Allocator>
std::size_t | boost::asio::write (Sync_Write_Stream &s, basic_streambuf< Allocator > &b)
| Write a certain amount of data to a stream before returning.
template<typename Sync_Write_Stream, typename Allocator, typename Completion_Condition>
std::size_t | boost::asio::write (Sync_Write_Stream &s, basic_streambuf< Allocator > &b, Completion_Condition completion_condition)
| Write a certain amount of data to a stream before returning.
template<typename Sync_Write_Stream, typename Allocator, typename Completion_Condition, typename Error_Handler>
std::size_t | boost::asio::write (Sync_Write_Stream &s, basic_streambuf< Allocator > &b, Completion_Condition completion_condition, Error_Handler error_handler)
| Write a certain amount of data to a stream before returning.

## Function Documentation

template<typename Sync_Write_Stream, typename Const_Buffers>

std::size_t boost::asio::write | ( | Sync_Write_Stream & | s,
|  | const Const_Buffers & | buffers |
| ) |  |  |

Write all of the supplied data to a stream before returning.

This function is used to write a certain number of bytes of data to a stream. The call will block until one of the following conditions is true:

- All of the data in the supplied buffers has been written. That is, the bytes transferred is equal to the sum of the buffer sizes.

- An error occurred.

This operation is implemented in terms of one or more calls to the stream's write_some function.

Parameters:

  | s | The stream to which the data is to be written. The type must support the Sync_Write_Stream concept.
  | buffers | One or more buffers containing the data to be written. The sum of the buffer sizes indicates the maximum number of bytes to write to the stream.

Returns:
  The number of bytes transferred.

Exceptions:

  | Sync_Write_Stream::error_type | Thrown on failure.

Example:
  To write a single data buffer use the boost::asio::buffer function as follows:

       boost::asio::write(s, boost::asio::buffer(data, size));

  See the boost::asio::buffer documentation for information on writing multiple buffers in one go, and how to use it with arrays, boost::array or std::vector.

Note:
  This overload is equivalent to calling:

       boost::asio::write(
           s, buffers,
           boost::asio::transfer_all(),
           boost::asio::throw_error());

template<typename Sync_Write_Stream, typename Const_Buffers, typename Completion_Condition>

std::size_t boost::asio::write | ( | Sync_Write_Stream & | s,
|  | const Const_Buffers & | buffers,
|  | Completion_Condition | completion_condition |
| ) |  |  |

Write a certain amount of data to a stream before returning.

This function is used to write a certain number of bytes of data to a stream. The call will block until one of the following conditions is true:

- All of the data in the supplied buffers has been written. That is, the bytes transferred is equal to the sum of the buffer sizes.

- The completion_condition function object returns true.

This operation is implemented in terms of one or more calls to the stream's write_some function.

Parameters:

  | s | The stream to which the data is to be written. The type must support the Sync_Write_Stream concept.
  | buffers | One or more buffers containing the data to be written. The sum of the buffer sizes indicates the maximum number of bytes to write to the stream.

  completion_condition

  The function object to be called to determine whether the write operation is complete. The signature of the function object must be:

       bool completion_condition(
         const Sync_Write_Stream::error_type& error, // Result of latest write_some
                                                     // operation.

         std::size_t bytes_transferred               // Number of bytes transferred
                                                     // so far.
       );

  A return value of true indicates that the write operation is complete. False indicates that further calls to the stream's write_some function are required.

Returns:
  The number of bytes transferred.

Exceptions:

  | Sync_Write_Stream::error_type | Thrown on failure.

Example:
  To write a single data buffer use the boost::asio::buffer function as follows:

       boost::asio::write(s, boost::asio::buffer(data, size),
           boost::asio::transfer_at_least(32));

  See the boost::asio::buffer documentation for information on writing multiple buffers in one go, and how to use it with arrays, boost::array or std::vector.

Note:
  This overload is equivalent to calling:

       boost::asio::write(
           s, buffers,
           completion_condition,
           boost::asio::throw_error());

template<typename Sync_Write_Stream, typename Const_Buffers, typename Completion_Condition, typename Error_Handler>

std::size_t boost::asio::write | ( | Sync_Write_Stream & | s,
|  | const Const_Buffers & | buffers,
|  | Completion_Condition | completion_condition,
|  | Error_Handler | error_handler |
| ) |  |  |

Write a certain amount of data to a stream before returning.

This function is used to write a certain number of bytes of data to a stream. The call will block until one of the following conditions is true:

- All of the data in the supplied buffers has been written. That is, the bytes transferred is equal to the sum of the buffer sizes.

- The completion_condition function object returns true.

This operation is implemented in terms of one or more calls to the stream's write_some function.

Parameters:

  | s | The stream to which the data is to be written. The type must support the Sync_Write_Stream concept.
  | buffers | One or more buffers containing the data to be written. The sum of the buffer sizes indicates the maximum number of bytes to write to the stream.

  completion_condition

  The function object to be called to determine whether the write operation is complete. The signature of the function object must be:

       bool completion_condition(
         const Sync_Write_Stream::error_type& error, // Result of latest write_some
                                                     // operation.

         std::size_t bytes_transferred               // Number of bytes transferred
                                                     // so far.
       );

  A return value of true indicates that the write operation is complete. False indicates that further calls to the stream's write_some function are required.

  error_handler

  A handler to be called when the operation completes, to indicate whether or not an error has occurred. Copies will be made of the handler as required. The function signature of the handler must be:

       void error_handler(
         const Sync_Write_Stream::error_type& error // Result of operation.
       );

Returns:
  The number of bytes written. If an error occurs, and the error handler does not throw an exception, returns the total number of bytes successfully transferred prior to the error.

template<typename Sync_Write_Stream, typename Allocator>

std::size_t boost::asio::write | ( | Sync_Write_Stream & | s,
|  | basic_streambuf< Allocator > & | b |
| ) |  |  |

Write a certain amount of data to a stream before returning.

This function is used to write a certain number of bytes of data to a stream. The call will block until one of the following conditions is true:

- All of the data in the supplied basic_streambuf has been written.

- An error occurred.

This operation is implemented in terms of one or more calls to the stream's write_some function.

Parameters:

  | s | The stream to which the data is to be written. The type must support the Sync_Write_Stream concept.
  | b | The basic_streambuf object from which data will be written.

Returns:
  The number of bytes transferred.

Exceptions:

  | Sync_Write_Stream::error_type | Thrown on failure.

Note:
  This overload is equivalent to calling:

       boost::asio::write(
           s, b,
           boost::asio::transfer_all(),
           boost::asio::throw_error());

template<typename Sync_Write_Stream, typename Allocator, typename Completion_Condition>

std::size_t boost::asio::write | ( | Sync_Write_Stream & | s,
|  | basic_streambuf< Allocator > & | b,
|  | Completion_Condition | completion_condition |
| ) |  |  |

Write a certain amount of data to a stream before returning.

This function is used to write a certain number of bytes of data to a stream. The call will block until one of the following conditions is true:

- All of the data in the supplied basic_streambuf has been written.

- The completion_condition function object returns true.

This operation is implemented in terms of one or more calls to the stream's write_some function.

Parameters:

  | s | The stream to which the data is to be written. The type must support the Sync_Write_Stream concept.
  | b | The basic_streambuf object from which data will be written.

  completion_condition

  The function object to be called to determine whether the write operation is complete. The signature of the function object must be:

       bool completion_condition(
         const Sync_Write_Stream::error_type& error, // Result of latest write_some
                                                     // operation.

         std::size_t bytes_transferred               // Number of bytes transferred
                                                     // so far.
       );

  A return value of true indicates that the write operation is complete. False indicates that further calls to the stream's write_some function are required.

Returns:
  The number of bytes transferred.

Exceptions:

  | Sync_Write_Stream::error_type | Thrown on failure.

Note:
  This overload is equivalent to calling:

       boost::asio::write(
           s, b,
           completion_condition,
           boost::asio::throw_error());

template<typename Sync_Write_Stream, typename Allocator, typename Completion_Condition, typename Error_Handler>

std::size_t boost::asio::write | ( | Sync_Write_Stream & | s,
|  | basic_streambuf< Allocator > & | b,
|  | Completion_Condition | completion_condition,
|  | Error_Handler | error_handler |
| ) |  |  |

Write a certain amount of data to a stream before returning.

This function is used to write a certain number of bytes of data to a stream. The call will block until one of the following conditions is true:

- All of the data in the supplied basic_streambuf has been written.

- The completion_condition function object returns true.

This operation is implemented in terms of one or more calls to the stream's write_some function.

Parameters:

  | s | The stream to which the data is to be written. The type must support the Sync_Write_Stream concept.
  | b | The basic_streambuf object from which data will be written.

  completion_condition

  The function object to be called to determine whether the write operation is complete. The signature of the function object must be:

       bool completion_condition(
         const Sync_Write_Stream::error_type& error, // Result of latest write_some
                                                     // operation.

         std::size_t bytes_transferred               // Number of bytes transferred
                                                     // so far.
       );

  A return value of true indicates that the write operation is complete. False indicates that further calls to the stream's write_some function are required.

  error_handler

  A handler to be called when the operation completes, to indicate whether or not an error has occurred. Copies will be made of the handler as required. The function signature of the handler must be:

       void error_handler(
         const Sync_Write_Stream::error_type& error // Result of operation.
       );

Returns:
  The number of bytes written. If an error occurs, and the error handler does not throw an exception, returns the total number of bytes successfully transferred prior to the error.

| Copyright © 2003 - 2006 Christopher M. Kohlhoff